template<class T>
class CountingSort :  public virtual SortAlgorithm<T>{
  private: T* tab;
  private: int size;
    
  public: CountingSort(T* tabel,int s){
    tab=tabel;
    size=s;
  }

  public: void sort(){
    T* nt = new T[size];
    
    //make a copy in the extra table (does not sort in place)
    //tab pointer can not be changed so final sorting has to be done in 
    //tab
    for(int i = 0; i<size;i++)
      nt[i]=tab[i];
    
    int max= (int) *(findMax()) ;
    max++;
    
    int *ft = new int[max];
    for(int i = 0; i<max;i++)
      ft[i]=0;
    
    for(int i = 0; i<size;i++)
      ft[nt[i]]++;
    
    for(int i = 1; i<max;i++)
      ft[i]+=ft[i-1];    
    
    for(int i = size - 1; i>=0;i--)
      tab[--ft[nt[i]]]=nt[i];
    delete[] ft;
    delete[] nt;    
  } 

  
  	//reverses a table;
	private: void reverse(){
		for (int i=0; i<size/2;i++){
			T current=tab[i];
			tab[i]=tab[size-i-1];  
			tab[size-i-1]=current;
		}	
	}
  
  private: T* findMax(){
    int max_index=0;
    for(int i = 0; i<size;i++)
      if(tab[i]>tab[max_index])
        max_index=i;
    return &tab[max_index];
  }
  
  public: string getName(){
    return "Counting Sort";
  }
};
