#include <iostream>
using namespace std;

template<class T>
class Heap{
  
  int max; //maximum number of elements allowed in heap
  int size; //number of elements currently stored in heap
  T* heap;
  
  public: Heap(int max_size,int used, T* array){
    max=max_size;
    heap=array;
    size=1;
    //used = number of elements used in the array (number of initialized elements)
    for(int i = 2;i<=used;i++){
      add(heap[i]);
    }    
  }
  
  public: void add(T element){
    if(size==max)
	    cerr<<"Maximum number of elements reached"<<endl;
    int index=size+1;
    while(index!=1 && element<heap[index/2]){
      heap[index]=heap[index/2];
      index /=2;
    }
    heap[index]=element;
    size++;
  }
  
  public: void replaceRoot(T new_root){
    T old_root = heap[1];
    if(new_root<= old_root)
      heap[1]=new_root;
    else
      traverseHeap(new_root);
  }
  
  private: void removeRoot(){
    replaceRoot(heap[size]);
    size--;	
  }
  
  private: void traverseHeap(T element){
    int index=1;
    int first_child=index*2;
    int second_child=index*2+1;    
    while(second_child <= size && ( heap[first_child]<element || heap[second_child]<element)){
    	if(heap[first_child]<heap[second_child]){
				heap[index]=heap[first_child];
				index=first_child;
			}else{
				heap[index]=heap[second_child];
				index=second_child;
			}
			first_child=index*2;
			second_child=index*2+1;
  	}//einde while
	heap[index]=element;  
  }
  
  public: void sort(){
    while(size>1){
      T smallest=heap[1];
      removeRoot();
      heap[size+1] = smallest;      
    }
  }  
};
