template<class T>
class QuickSmartPivotSort : public virtual SortAlgorithm<T>{
  
  private: T* tab;
  private: int size;
    
  public: QuickSmartPivotSort(T* table, int s){
    srand(time(0));
    tab=table;
    size=s;
  }
  
  public: void sort(){
    quicksort(0,size-1);
  }
  
  private: void quicksort(int left, int right){
    if(right > left){
      T pivot = *(superSmartAINeuroAlgorithmPivotChooser(left,right));
      int j = right;
      int i = left;
      while(pivot<tab[j]) j--;
      while(i<j){
        T temp=tab[i] ;tab[i]=tab[j]; tab[j]=temp;
        i++;
        while(pivot>tab[i])i++;
        j--;
        while(pivot<tab[j])j--;
      }
      quicksort(left,j);
      quicksort(j+1,right);
    }    
  }
  
  private: T* superSmartAINeuroAlgorithmPivotChooser(int left, int right){
    T* pivot = &tab[left];
    if((right-left)>3){
      int random;
      random = rand() % (right-left+1) + left;
      T pivot1 = tab[random];
      random = rand() % (right-left+1) + left;
      T pivot2 = tab[random];
      random = rand() % (right-left+1) + left;
      T pivot3 = tab[random];
      
      if(pivot1<pivot2 && pivot2>pivot3){
        pivot=&pivot2;
      }else if(pivot1<pivot3 && pivot3>pivot2){
        pivot = &pivot3;
      }else{
        pivot = &pivot1;
      }      
    }
    return pivot;
  }  
  
  public: string getName(){
    return "Quicksort with smart pivot";
  }
};
