template<class T>
class QuickerSort  : public virtual SortAlgorithm<T> {
	private: T* tab;
	private: int size;
  private: int cutoff;
	public: QuickerSort(T* table,int table_size,int co){
		size = table_size;
		tab=table;
    cutoff=co;
	}
	
	public: void sort(){
    srand(time(0));
		quicksort(0,size-1);
	}
	
	//quicksort with random pivot:
	private: void quicksort(int left, int right){
		if((right-left)>8){
      //random pivot:
      int index = rand() % (right - left + 1) + left;
      //cout <<"left: "<<left<<" right : "<<right<<" index: "<<index<<endl;
			T pivot =tab[index];
			int i =left;
			int j = right;
			
			while(tab[j]>pivot)j--;
			while(i<j){
				T temp = tab[i];
				tab[i]=tab[j];
				tab[j]=temp;
				i++;
				while(tab[i]<pivot)i++;
				j--;
				while(tab[j]>pivot)j--;
			}
			quicksort(left,j);
			quicksort(j+1,right);
		}else{
      insertionsort(left,right);
    }
	}
  
  private: void insertionsort(int left, int right){
    for(int i = left ; i<=right ; i++ ) {
        T element = tab[i];
        int j = i - 1;
        while(j>-1 && tab[j]>element){
          tab[j+1]=tab[j];
          j--;
        }
        tab[j+1]=element;
    }
  }
	
	public: string getName(){
		return "Quick Sort with cutoff";
	}
};

