

template<class T>
class SixSort  : public virtual SortAlgorithm<T> {
	
	private: T* tab;
	private: int size;
	private: int* increments_table;
	private: int increments_size;
		
	private: void initializeSedgewick(){
		int sedgewick_inc[]={1,3,5,19,41,109,209,505,929,2161,
		3905,8929,16001,36289,64769,146305,260609,587521,1045505,2354689,
		4188161,9427969,16764929,37730305,67084289,150958081,268386305,
		603906049,1073643521};
		increments_size=0;
		int element=sedgewick_inc[increments_size];
		while(element< (int) (size/3)){
			element=sedgewick_inc[increments_size++];
		}
		increments_table = new int [increments_size];
		for(int i=0;i<increments_size;i++){
			increments_table[i]=sedgewick_inc[i];
		}
	}
	
	public: void sort(){
    int incr_index = increments_size-1;
    while(incr_index>1){
      int k  = increments_table[incr_index];
      for(int i =  k ; i < size ; i++){
        int j = i-k;
        T huidig_element = tab[i];
        while(j>=0 &&  huidig_element<tab[j]){
          tab[j+k]=tab[j];
          j-=k;
        }
        tab[j+k]=huidig_element;
      }
      incr_index--;
    }
    insertionsort();
	}
  
  private: void insertionsort(){
    for(int i=0;i<size;i++){
      T element = tab[i];
      int j = i - 1 ;
      while(j>-1 && tab[j]>element){
        tab[j+1]=tab[j];
        j--;
      }
      tab[j+1]=element;
    }
  }
	
	public: SixSort(T* table,int table_size){
		size = table_size;
		tab=table;
    initializeSedgewick();
	}
	
	public: ~SixSort(){
		delete[] increments_table;
	}
	
	public: string getName(){
		return "Six Sort (Shell sort with cutoff to insertion sort) ";
	}
	
};







